//
//  STImage.h
//  Kahuna
//
//  Created by Davyd Geyl on 5/07/10.
//  Copyright 2010 Sportstec Ltd. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class STColor;

@interface STImage : NSObject
{
	NSImage* _image;
	CGImageRef _CGImage;
}

+ (instancetype)imageNamed:(NSString *)name;
+ (instancetype)imageWithData:(NSData*)imageData;
+ (instancetype)imageWithImageObject:(id)imageObject;

@property(nonatomic, readonly) CGSize size;
@property(nonatomic, readonly) CGImageRef CGImage;
@property(nonatomic, readonly) NSData* imageData;

@property (nonatomic, readonly) NSImage* image;
@property (nonatomic, readonly) NSBitmapImageRep* bitmapRepresentation;

- (instancetype)initWithCGImage:(CGImageRef)CGImage;
- (instancetype)initWithImageObject:(id)imageObject;

- (STColor*)colorAtPoint:(CGPoint)point;

- (STImage*)scaleToSize:(CGSize)size;
- (STImage*)cropWithRect:(CGRect)cropRect;

- (void)drawInRect:(CGRect)rect;

@end
